function HUDManager:_create_stud_count(safe_hud, fullscreen_hud)
	safe_hud = safe_hud or managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
	fullscreen_hud = fullscreen_hud or managers.hud:script(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)

	self._hud_stud_count = HUDStudCount:new(safe_hud, fullscreen_hud, self._sound_source)
end

function HUDManager:add_studs(icon, value, world_position)
	local camera = managers.viewport:get_current_camera()

	if camera then
		self._hud_stud_count:spawn_stud(icon, value, self._saferect:world_to_screen(camera, world_position))
	else
		self._hud_stud_count:add_value(icon, value)
	end
end

function HUDManager:set_stud_count(count, silent)
	self._hud_stud_count:set_stud_count(count, silent)
end

function HUDManager:set_true_heister_value(value, already_completed)
	self._hud_stud_count:set_true_heister_value(value, already_completed)
end

Hooks:PostHook(HUDManager, "init_finalize", "init_lego_studs", function(self)
	if not (self:alive(PlayerBase.PLAYER_INFO_HUD_PD2) or self:alive(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)) then
		return
	end

	local safe_hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
	local fullscreen_hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)

	self:_create_stud_count(safe_hud, fullscreen_hud)
end)